Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.wrapper
Class VirtualCopy

    java.lang.Object
      net.sf.saxon.tree.wrapper.VirtualCopy

All Implemented Interfaces:
  Source, SourceLocator, PullEvent, Item<NodeInfo>, NodeInfo, ValueRepresentation<NodeInfo>

Direct Known Subclasses:
  VirtualDocumentCopy, VirtualUntypedCopy

    public class VirtualCopy

extends Object
implements NodeInfo, SourceLocator

This class represents a node that is a virtual copy of another node: that is, it behaves as a node that's the same as another node, but has different identity. Moreover, this class can create a virtual copy of a subtree, so that the parent of the virtual copy is null rather than being a virtual copy of the parent of the original. This means that none of the axes when applied to the virtual copy is allowed to stray outside the subtree. The virtual copy is implemented by means of a reference to the node of which it is a copy, but methods that are sensitive to node identity return a different result.

Nested Class Summary
`protected class` | `VirtualCopy.VirtualCopier` VirtualCopier implements the XPath axes as applied to a VirtualCopy node.

Field Summary
`protected long` | `documentNumber`
`protected NodeInfo` | `original`
`protected VirtualCopy` | `parent`
`protected NodeInfo` | `root`
`protected String` | `systemId`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`protected` | `VirtualCopy(NodeInfo base)` Protected constructor: create a virtual copy of a node

Method Summary
`Value` | `atomize()` Get the typed value.
`int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`void` | `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given outputter
`boolean` | `equals(Object other)` The equals() method compares nodes for identity.
`void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node.
`String` | `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`String` | `getAttributeValue(String uri, String local)` Get the string value of a given attribute of this node
`String` | `getBaseURI()` Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
`int` | `getColumnNumber()` Get column number
`Configuration` | `getConfiguration()` Get the configuration
`NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`String` | `getDisplayName()` Get the display name of this node.
`long` | `getDocumentNumber()` Get the document number of the document containing this node.
`DocumentInfo` | `getDocumentRoot()` Get the root node, if it is a document node.
`int` | `getFingerprint()` Get fingerprint.
`int` | `getLineNumber()` Get line number
`String` | `getLocalPart()` Get the local part of the name of this node.
`int` | `getNameCode()` Get name code.
`NamePool` | `getNamePool()` Get the NamePool that holds the namecode for this node
`int` | `getNodeKind()` Get the kind of node.
`NodeInfo` | `getParent()` Get the NodeInfo object representing the parent of this node
`String` | `getPrefix()` Get the prefix of the name of the node.
`String` | `getPublicId()` Return the public identifier for the current document event.
`NodeInfo` | `getRoot()` Get the root node of the tree containing this node
`SchemaType` | `getSchemaType()` Get the type annotation of this node, if any.
`String` | `getStringValue()` Return the string value of the node.
`CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`String` | `getSystemId()` Get the System ID for the node.
`int` | `getTypeAnnotation()` Get the type annotation of this node, if any.
`SequenceIterator` | `getTypedValue()` Get the typed value of the item
`String` | `getURI()` Get the URI part of the name of this node.
`boolean` | `hasChildNodes()` Determine whether the node has any children.
`int` | `hashCode()` The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
`boolean` | `isId()` Determine whether this node has the is-id property
`boolean` | `isIdref()` Determine whether this node has the is-idref property
`boolean` | `isNilled()` Determine whether the node has the is-nilled property
`boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node.
`AxisIterator` | `iterateAxis(byte axisNumber)` Return an iteration over all the nodes reached by the given axis from this node
`AxisIterator` | `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest
`protected VirtualCopy.VirtualCopier` | `makeCopier(AxisIterator axis, VirtualCopy newParent, NodeInfo root)` Create an iterator that makes and returns virtual copies of nodes on the original tree
`static VirtualCopy` | `makeVirtualCopy(NodeInfo original, NodeInfo root)` Public factory method: create a virtual copy of a node
`void` | `setDocumentNumber(long documentNumber)` Set the unique document number of the virtual document.
`void` | `setSystemId(String systemId)` Set the system identifier for this Source.
`protected VirtualCopy` | `wrap(NodeInfo node)` Wrap a node in a VirtualCopy.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### systemId

    protected String systemId

### documentNumber

    protected long documentNumber

### original

    protected NodeInfo original

### parent

    protected VirtualCopy parent

### root

    protected NodeInfo root

Constructor Detail

### VirtualCopy

    protected VirtualCopy(NodeInfo base)

  Protected constructor: create a virtual copy of a node

  Parameters:
    `base` - the node to be copied

Method Detail

### makeVirtualCopy

    public static VirtualCopy makeVirtualCopy(NodeInfo original,
                                              NodeInfo root)

  Public factory method: create a virtual copy of a node

  Parameters:
    `original` - the node to be copied
    `root` - the root of the tree containing the node to be copied
  Returns:
    the virtual copy. If the original was already a virtual copy, this will be a virtual copy of the real underlying node.

### wrap

    protected VirtualCopy wrap(NodeInfo node)

  Wrap a node in a VirtualCopy. This method is designed for subclassing

  Parameters:
    `node` - the node to be wrapped

### setDocumentNumber

    public void setDocumentNumber(long documentNumber)

  Set the unique document number of the virtual document. This method must be called to ensure that nodes in the virtual copy have unique node identifiers

  Parameters:
    `documentNumber` - the document number to be allocated. This can be obtained from the `DocumentNumberAllocator` which is accessible from the Configuration using `Configuration.getDocumentNumberAllocator()`

### getNodeKind

    public int getNodeKind()

  Get the kind of node. This will be a value such as Type.ELEMENT or Type.ATTRIBUTE

  Specified by:
    `getNodeKind` in interface `NodeInfo`
  Returns:
    an integer identifying the kind of node. These integer values are the same as those used in the DOM
  See Also:
    `Type`

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node. Note: a.isSameNodeInfo(b) if and only if generateId(a)==generateId(b). This method has the same semantics as isSameNode() in DOM Level 3, but works on Saxon NodeInfo objects rather than DOM Node objects.

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.

### equals

    public boolean equals(Object other)

  The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().

  Specified by:
    `equals` in interface `NodeInfo`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
  Since:
    8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

### hashCode

    public int hashCode()

  The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()

  Specified by:
    `hashCode` in interface `NodeInfo`
  Overrides:
    `hashCode` in class `Object`
  Since:
    8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

### getSystemId

    public String getSystemId()

  Get the System ID for the node.

  Specified by:
    `getSystemId` in interface `Source`
  Specified by:
    `getSystemId` in interface `SourceLocator`
  Specified by:
    `getSystemId` in interface `NodeInfo`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

### getBaseURI

    public String getBaseURI()

  Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. This will be the same as the System ID unless xml:base has been used.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Returns:
    the base URI of the node

### getLineNumber

    public int getLineNumber()

  Get line number

  Specified by:
    `getLineNumber` in interface `SourceLocator`
  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Returns:
    the line number of the node in its original source document; or -1 if not available

### getColumnNumber

    public int getColumnNumber()

  Get column number

  Specified by:
    `getColumnNumber` in interface `SourceLocator`
  Specified by:
    `getColumnNumber` in interface `NodeInfo`
  Returns:
    the column number of the node in its original source document; or -1 if not available

### compareOrder

    public int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getStringValue

    public String getStringValue()

  Return the string value of the node. The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.

  Specified by:
    `getStringValue` in interface `Item<NodeInfo>`
  Specified by:
    `getStringValue` in interface `NodeInfo`
  Specified by:
    `getStringValue` in interface `ValueRepresentation<NodeInfo>`
  Returns:
    the string value of the node
  See Also:
    `Item.getStringValueCS()`

### getStringValueCS

    public CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item<NodeInfo>`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation<NodeInfo>`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### getNameCode

    public int getNameCode()

  Get name code. The name code is a coded form of the node name: two nodes with the same name code have the same namespace URI, the same local name, and the same prefix. By masking the name code with &0xfffff, you get a fingerprint: two nodes with the same fingerprint have the same local name and namespace URI.

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool
  See Also:
    `allocate`, `getFingerprint`

### getFingerprint

    public int getFingerprint()

  Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. A fingerprint of -1 should be returned for a node with no name.

  Specified by:
    `getFingerprint` in interface `NodeInfo`
  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName

### getLocalPart

    public String getLocalPart()

  Get the local part of the name of this node. This is the name after the ":" if any.

  Specified by:
    `getLocalPart` in interface `NodeInfo`
  Returns:
    the local part of the name. For an unnamed node, returns "". Unlike the DOM interface, this returns the full name in the case of a non-namespaced name.

### getURI

    public String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Specified by:
    `getURI` in interface `NodeInfo`
  Returns:
    The URI of the namespace of this node. For an unnamed node, or for a node with an empty prefix, return an empty string.

### getPrefix

    public String getPrefix()

  Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.

  Specified by:
    `getPrefix` in interface `NodeInfo`
  Returns:
    The prefix of the name of the node.

### getDisplayName

    public String getDisplayName()

  Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.

  Specified by:
    `getDisplayName` in interface `NodeInfo`
  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration

  Specified by:
    `getConfiguration` in interface `NodeInfo`
  Returns:
    the Configuration

### getNamePool

    public NamePool getNamePool()

  Get the NamePool that holds the namecode for this node

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Returns:
    the namepool

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any.

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Returns:
    the type annotation of the node.
  See Also:
    `Type`

### getSchemaType

    public SchemaType getSchemaType()

  Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

  Types derived from a DTD are not reflected in the result of this method.

  Specified by:
    `getSchemaType` in interface `NodeInfo`
  Returns:
    For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
  Since:
    9.4

### getParent

    public NodeInfo getParent()

  Get the NodeInfo object representing the parent of this node

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    the parent of this node; null if this node has no parent

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an iteration over all the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - an integer identifying the axis; one of the constants defined in class net.sf.saxon.om.Axis
  Returns:
    an AxisIterator that scans the nodes reached by the axis in turn.
  Throws:
    `UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an iteration over all the nodes reached by the given axis from this node that match a given NodeTest

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - an integer identifying the axis; one of the constants defined in class net.sf.saxon.om.Axis
    `nodeTest` - A pattern to be matched by the returned nodes; nodes that do not match this pattern are not included in the result
  Returns:
    an AxisIterator that scans the nodes reached by the axis in turn.
  Throws:
    `UnsupportedOperationException` - if the namespace axis is requested and this axis is not supported for this implementation.
  See Also:
    `Axis`

### getAttributeValue

    public String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getAttributeValue

    public String getAttributeValue(String uri,
                                    String local)

  Get the string value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
    `local` - the local part of the attribute name.
  Returns:
    the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.

### getRoot

    public NodeInfo getRoot()

  Get the root node of the tree containing this node

  Specified by:
    `getRoot` in interface `NodeInfo`
  Returns:
    the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root node, if it is a document node.

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Returns:
    the DocumentInfo representing the containing document. If this node is part of a tree that does not have a document node as its root, return null.

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.
  Note: the result is equivalent to
  getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Returns:
    True if the node has one or more children

### generateId

    public void generateId(FastStringBuffer buffer)

  Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)

  Specified by:
    `generateId` in interface `NodeInfo`
  Parameters:
    `buffer` - a buffer, to which will be appended a string that uniquely identifies this node, across all documents.

### getDocumentNumber

    public long getDocumentNumber()

  Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`
  Returns:
    the document number of the document containing this node

### copy

    public void copy(Receiver out,
                     int copyOptions,
                     int locationId)
              throws XPathException

  Copy this node to a given outputter

  Specified by:
    `copy` in interface `NodeInfo`
  Parameters:
    `out` - the Receiver to which the node should be copied
    `copyOptions` - a selection of the options defined in `CopyOptions`
    `locationId` - Identifies the location of the instruction
  Throws:
    `XPathException` - if any downstream error occurs

### getDeclaredNamespaces

    public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### setSystemId

    public void setSystemId(String systemId)

  Set the system identifier for this Source.

  The system identifier is optional if the source does not get its data from a URL, but it may still be useful to provide one. The application can use a system identifier, for example, to resolve relative URIs and to include in error messages and warnings.

  Specified by:
    `setSystemId` in interface `Source`
  Parameters:
    `systemId` - The system identifier as a URL string.

### getTypedValue

    public SequenceIterator getTypedValue()
                                   throws XPathException

  Get the typed value of the item

  Specified by:
    `getTypedValue` in interface `Item<NodeInfo>`
  Returns:
    the typed value of the item. In general this will be a sequence
  Throws:
    `XPathException` - where no typed value is available, e.g. for an element with complex content

### atomize

    public Value atomize()
                  throws XPathException

  Get the typed value. The result of this method will always be consistent with the method `Item.getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `NodeInfo`
  Returns:
    the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
  Throws:
    `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
  Since:
    8.5

### isId

    public boolean isId()

  Determine whether this node has the is-id property

  Specified by:
    `isId` in interface `NodeInfo`
  Returns:
    true if the node is an ID

### isIdref

    public boolean isIdref()

  Determine whether this node has the is-idref property

  Specified by:
    `isIdref` in interface `NodeInfo`
  Returns:
    true if the node is an IDREF or IDREFS element or attribute

### isNilled

    public boolean isNilled()

  Determine whether the node has the is-nilled property

  Specified by:
    `isNilled` in interface `NodeInfo`
  Returns:
    true if the node has the is-nilled property

### getPublicId

    public String getPublicId()

  Return the public identifier for the current document event.

  The return value is the public identifier of the document entity or of the external parsed entity in which the markup that triggered the event appears.

  Specified by:
    `getPublicId` in interface `SourceLocator`
  Returns:
    A string containing the public identifier, or null if none is available.
  See Also:
    `getSystemId()`

### makeCopier

    protected VirtualCopy.VirtualCopier makeCopier(AxisIterator axis,
                                                   VirtualCopy newParent,
                                                   NodeInfo root)

  Create an iterator that makes and returns virtual copies of nodes on the original tree

  Parameters:
    `axis` - the axis to be navigated
    `newParent` - the parent of the nodes in the new virtual tree (may be null)
    `root` - the root of the virtual tree
  Returns:
    the iterator that does the copying

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.